<?php

/**
 * @file
 * Post update functions for Plugin reference.
 */

use Drupal\Core\Config\Entity\ConfigEntityUpdater;
use Drupal\Core\Entity\Display\EntityFormDisplayInterface;

/**
 * Add configuration_form to the plugin reference widgets.
 */
function pluginreference_post_update_add_configuration_form_option_to_widget(&$sandbox = NULL) {
  \Drupal::classResolver(ConfigEntityUpdater::class)
    ->update($sandbox, 'entity_form_display', function (EntityFormDisplayInterface $form_display) {
      $pluginreference_widgets = [
        'plugin_reference_autocomplete',
        'plugin_reference_select',
      ];

      $updated = FALSE;
      foreach ($form_display->getComponents() as $id => $component) {
        if (isset($component['type']) && in_array($component['type'], $pluginreference_widgets, TRUE) && !isset($component['settings']['configuration_form'])) {
          $component['settings']['configuration_form'] = 'hidden';
          $form_display->setComponent($id, $component);
          $updated = TRUE;
        }
      }

      return $updated;
    });
}
