<?php

namespace Drupal\Tests\pluginreference\Functional;

use Drupal\Tests\BrowserTestBase;
use Drupal\Tests\field_ui\Traits\FieldUiTestTrait;

/**
 * Test the creation of an plugin reference in the UI.
 *
 * @group pluginreference
 */
class PluginReferenceFieldCreationTest extends BrowserTestBase {

  use FieldUiTestTrait;

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stark';

  /**
   * Modules to enable.
   *
   * @var array
   */
  protected static $modules = ['block', 'field_ui', 'node', 'pluginreference'];

  /**
   * {@inheritdoc}
   */
  protected function setUp(): void {
    parent::setUp();

    $this->drupalPlaceBlock('system_breadcrumb_block');
    $this->drupalLogin($this->rootUser);
    $this->drupalCreateContentType(['type' => 'page']);
  }

  /**
   * Test the creation of a plugin reference field in the UI.
   */
  public function testPluginReferenceFieldCreation() {
    $this->fieldUIAddNewField(
      'admin/structure/types/manage/page',
      'field_pluginreference',
      'Pluginreference',
      'plugin_reference',
      [
        'settings[target_type]' => 'block',
      ]);
  }

}
